[WXM] LeetCode 377. Combination Sum IV C++

377. Combination Sum IV

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.

Example:

nums = [1, 2, 3]
target = 4

The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)

Note that different sequences are counted as different combinations.

Therefore the output is 7.
Follow up:
What if negative numbers are allowed in the given array?
How does it change the problem?
What limitation we need to add to the question to allow negative numbers?

Credits:
Special thanks to @pbrother for adding this problem and creating all test cases.

Approch

  1. 题目大意就是nums中有多少个组合可以组成target,一开始我采用记忆化搜索,发现一直超时,最后看了大神的播客才明白,这里要采用递推的方式,因为是数据的问题,所以用递归方式是行不通的,然后怎么递推呢,我们初始化dp[0]=1,然后枚举1~target,减去nums中任意的数,只要能到达0既可以,所以得出递推式dp[i]+=dp[i-nums[j]],数组边界的问题,要保证i>=nums[j]

Code

class Solution {
public:
    int combinationSum4(vector<int>& nums, int target) {
        int n = nums.size();
        vector<int> dp(target + 1, 0);
        dp[0] = 1;
        for (int i = 1; i <= target; i++) {
            for (int &n : nums) {
                if (i >= n) {
                    dp[i] += dp[i - n];
                }
            }
        }
        return dp.back();
    }
};

猜你喜欢

转载自blog.csdn.net/WX_ming/article/details/81983450
今日推荐